﻿using System;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using Microsoft.AspNetCore.Components;
using Microsoft.JSInterop;
using myBlazorApp.Models;
using myBlazorApp.Services;
namespace myBlazorApp.Components
{
    public partial class MyInventory
    {
        [Parameter]
        public List<Item> ItemsInventory { get; set; } = new List<Item>();

        [Parameter]
        public int index { get; set; } = 0;

        public ObservableCollection<InventoryAction> Actions { get; set; }

        public Item CurrentDragItem { get; set; } = new Item();

        public MyInventory()
        {
            Actions = new ObservableCollection<InventoryAction>();
            Actions.CollectionChanged += OnActionsCollectionChanged;
        }

        [Inject]
        public IDataService DataService { get; set; }

        [Inject]
        public IWebHostEnvironment WebHostEnvironment { get; set; }

        [Inject]
        public NavigationManager NavigationManager { get; set; }

        [Inject]
        internal IJSRuntime JavaScriptRuntime { get; set; }

        private void OnActionsCollectionChanged(object? sender, NotifyCollectionChangedEventArgs e)
        {
            JavaScriptRuntime.InvokeVoidAsync("MyInventory.AddActions", e.NewItems);
        }
    }
}

